#ifndef BLACK_BOX_INCREMENTAL_MAXTERM_H
#define BLACK_BOX_INCREMENTAL_MAXTERM_H

/*
 * cipher key iv num_parallell_bits num_bits_in_bit_set bit1 bit2 bit3 ...
 *
 * cipher = number in [0 ... kNumBlackBoxCiphers]
 * key = digit 0 indicating zero key fill or
 *       digit 1 indicating ones key fill or
 *       digit 2 indicating random key fill or
 *       explicit (hex buffer as string, 07AB...)
 * iv = digit 0 indicating zero iv fill or
 *      digit 1 indicating ones iv fill or
 *      digit 2 indicating random iv fill or
 *      explicit (hex buffer as string, 07AB...)
 * num_parallell_bits = number (not too high)
 * num_key_bits_in_bit_set = number
 * key bits = a sequence of sufficiently many bit indices in [0 .. numKeyBits-1]
 * num_iv_bits_in_bit_set = number
 * iv bits = a sequence of sufficiently many bit indices in [0 .. numIvBits-1]
 */
int blackBoxIncrementalMaxterm(int argc, char **argv);

#endif

